<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="java.util.Arrays" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.CarbonError"%>
<%@page import="org.wso2.carbon.ui.CarbonUIMessage"%>
<script type="text/javascript" src="../userstore/extensions/js/vui.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>

<script language="javascript">
 function submitForm(action){
   location.href = action;
 }
</script>

<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String roleName = (String) request.getParameter("roleName");
    String userType = (String) request.getParameter("userType");
    String[] users = new String[0];
    String[] systemPermissions = new String[0];
    String description = null;
    String action=null;
    try {
        UserMgtClient client = new UserMgtClient(cookie, backendServerURL, configContext);
        if ("special".equals(userType)) {
            users = client.getUsersOfSpecialInternalRole(roleName);
            systemPermissions = client.getSystemPermissionsOfSpecialInternalRole(roleName);
            description = "Internal role with external users";
            action="../userstore/ex-role-mgt.jsp?ordinal=1";
        } else if("external".equals(userType)){
            users = client.getUsersInExternalRole(roleName);
            systemPermissions = client.getSystemPermissionsOfExternalRole(roleName);
            description = "External role";
            action="../userstore/ex-role-mgt.jsp?ordinal=1";
        } else {
            users = client.getUsersInRole(roleName);
            systemPermissions = client.getSystemPermissionsOfRole(roleName);
            description = "Internal roles";
            action="role-mgt.jsp?ordinal=1";
        }
    } catch (Exception e) {
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
        <jsp:include page="../admin/error.jsp"/>
<%
        return;
    }
    

    String userString = Arrays.toString(users);
    if("null".equals(userString)){
	    userString = "";
    } else if (userString.length() > 1) {
        userString = userString.substring(1, userString.length() - 1);
    }
    
    String permissionString = Arrays.toString(systemPermissions);
    if("null".equals(permissionString)){
	   permissionString = "";
    }else if (permissionString.length() > 1) {
        permissionString = permissionString.substring(1, permissionString.length() - 1);
    }
%>
<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
<carbon:breadcrumb label="view.role.details"
		resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
		topPage="false" request="<%=request%>" />

    <div id="middle">
        <h2><fmt:message key="view.role.details"/></h2>

        <div id="workArea">
            <table class="styledLeft" width="100%">
                        <thead>
			                <tr>
			                    <th><fmt:message key="name"/></th>
			                    <th><fmt:message key="value"/></th>
			                </tr>
		                </thead>
		                <tbody>
                            <tr>
                                <td><fmt:message key="role.name"/></td>
                                <td><%=roleName%></td>
                            </tr>
                            <tr>
                                <td><fmt:message key="role.description"/></td>
                                <td><%=description%></td>
                            </tr>
                            <tr>
                                <td><fmt:message key="assigned.permissions"/></td>
                                <td><%=permissionString%></td>
                            </tr>
                            <tr>
                                <td><fmt:message key="assigned.users"/></td>
                                <td><%=userString%></td>
                            </tr>
                            <tr>
			                    <td class="buttonRow" colspan="2">
			                        <form name="form1" action="" onsubmit="javascript:submitForm(<%="'"+action+"'"%>);return false;">
			                        <input value="<fmt:message key="back.to.roles.list"/>" type="submit" class="button"/>
			                        </form>
			                    </td>
			                </tr>
			             </tbody>
            </table>
        </div>
    </div>
</fmt:bundle>