<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.server.admin.ui.types.carbon.ServerData" %>
<%@ page import="org.wso2.carbon.server.admin.ui.ServerAdminClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.apache.http.HttpStatus" %>

<fmt:bundle basename="org.wso2.carbon.server.admin.ui.i18n.Resources">
<%
    response.setHeader("Cache-Control", "no-cache");

    //Obtaining the client-side ConfigurationContext instance.
    ConfigurationContext configContext = (ConfigurationContext) config.getServletContext()
            .getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    //Server URL which is defined in the server.xml
    String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(),
            session);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    ServerData data;
    try {
        ServerAdminClient client = new ServerAdminClient(configContext, serverURL, cookie, session);
        data = client.getServerData();
    } catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
        <jsp:include page="../admin/error.jsp"/>
<%
        return;
    }
%>

<table id="systemInfoTable" width="100%" class="styledLeft">
    <thead>
    <tr>
        <th colspan="2"><fmt:message key="server"/></th>
    </tr>
    </thead>
    <tr>
        <td><fmt:message key="host"/></td>
        <td><%= data.getServerIp()%>
        </td>
    </tr>
    <tr>
        <td>
            <fmt:message key="server.url"/>
        </td>
        <td>
            <%= serverURL%>
        </td>
    </tr>
    <tr>
        <td><fmt:message key="server.start.time"/></td>
        <td><%= data.getServerStartTime()%>
        </td>
    </tr>
    <tr>
        <td><fmt:message key="system.up.time"/></td>
        <td><%= data.getSystemUpTime()%>
        </td>
    </tr>
    <tr>
        <td width="15%"><fmt:message key="version"/></td>
        <td>
            <%= data.getWso2WsasVersion()%>
        </td>
    </tr>
    <tr>
        <td>
            <fmt:message key="repository.location"/>
        </td>
        <td>
            <%= data.getRepoLocation()%>
        </td>
    </tr>
</table>

<p>&nbsp;</p>

<table id="serverTable" width="100%" class="styledLeft">
    <thead>
    <tr>
        <th colspan="2"><fmt:message key="operating.system"/></th>
    </tr>
    </thead>
    <tr>
        <td width="15%">
            <fmt:message key="os.name"/>
        </td>
        <td>
            <%= data.getOsName()%>
        </td>
    </tr>
    <tr>
        <td>
            <fmt:message key="os.version"/>
        </td>
        <td>
            <%= data.getOsVersion()%>
        </td>
    </tr>
</table>

<p>&nbsp;</p>
<table id="userTable" width="100%" class="styledLeft">
    <thead>
    <tr>
        <th colspan="2"><fmt:message key="user"/></th>
    </tr>
    </thead>
    <tr>
        <td width="15%">
            <fmt:message key="user.country"/>
        </td>
        <td>
            <%= data.getUserCountry()%>
        </td>
    </tr>
    <tr>
        <td>
            <fmt:message key="user.home"/>
        </td>
        <td>
            <%= data.getUserHome()%>
        </td>
    </tr>
    <tr>
        <td><fmt:message key="user.name"/></td>
        <td>
            <%= data.getUserName()%>
        </td>
    </tr>
    <tr>
        <td><fmt:message key="user.timezone"/></td>
        <td>
            <%= data.getUserTimezone()%>
        </td>
    </tr>
</table>

<p>&nbsp;</p>
<table id="vmTable" width="100%" class="styledLeft">
    <thead>
    <tr>
        <th colspan="2"><fmt:message key="java.vm"/></th>
    </tr>
    </thead>
    <tr>
        <td width="15%">
            <fmt:message key="java.home"/>
        </td>
        <td>
            <%= data.getJavaHome()%>
        </td>
    </tr>
    <tr>
        <td>
            <fmt:message key="java.runtime.name"/>
        </td>
        <td>
            <%= data.getJavaRuntimeName()%>
        </td>
    </tr>
    <tr>
        <td>
            <fmt:message key="java.version"/>
        </td>
        <td>
            <%= data.getJavaVersion()%>
        </td>
    </tr>
    <tr>
        <td>
            <fmt:message key="java.vendor"/>
        </td>
        <td>
            <%= data.getJavaVMVendor()%>
        </td>
    </tr>
    <tr>
        <td>
            <fmt:message key="java.vm.version"/>
        </td>
        <td>
            <%= data.getJavaVMVersion()%>
        </td>
    </tr>
</table>


<p>&nbsp;</p>
<table id="registryTable" width="100%" class="styledLeft">
    <thead>
    <tr>
        <th colspan="2"><fmt:message key="registry"/></th>
    </tr>
    </thead>
    <tr>
        <td width="15%">
            <fmt:message key="registry.type"/>
        </td>
        <td>
            <%= data.getRegistryType()%>
        </td>
    </tr>
<% if(data.getRegistryType().equals("embedded")) { %>
    <tr>
        <td width="15%">
            <fmt:message key="registry.db.name"/>
        </td>
        <td>
            <%= data.getDbName()%>
        </td>
    </tr>
    <tr>
        <td width="15%">
            <fmt:message key="registry.db.version"/>
        </td>
        <td>
            <%= data.getDbVersion()%>
        </td>
    </tr>
    <tr>
        <td width="15%">
            <fmt:message key="registry.db.driver.name"/>
        </td>
        <td>
            <%= data.getDbDriverName()%>
        </td>
    </tr>
    <tr>
        <td width="15%">
            <fmt:message key="registry.db.driver.version"/>
        </td>
        <td>
            <%= data.getDbDriverVersion()%>
        </td>
    </tr>
    <tr>
        <td width="15%">
            <fmt:message key="registry.db.url"/>
        </td>
        <td>
            <%= data.getDbURL()%>
        </td>
    </tr>
<% } else if (data.getRegistryType().equals("remote")) { %>
    <tr>
        <td width="15%">
            <fmt:message key="registry.url"/>
        </td>
        <td>
            <%= data.getRemoteRegistryURL()%>
        </td>
    </tr>
    <tr>
        <td width="15%">
            <fmt:message key="registry.chroot"/>
        </td>
        <td>
            <%= data.getRemoteRegistryChroot()%>
        </td>
    </tr>
<% } %>    
</table>

<script type="text/javascript">
    alternateTableRows('systemInfoTable', 'tableEvenRow', 'tableOddRow');
    alternateTableRows('serverTable', 'tableEvenRow', 'tableOddRow');
    alternateTableRows('userTable', 'tableEvenRow', 'tableOddRow');
    alternateTableRows('vmTable', 'tableEvenRow', 'tableOddRow');
    alternateTableRows('registryTable', 'tableEvenRow', 'tableOddRow');
</script>

</fmt:bundle>