<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.CarbonError" %>
<script type="text/javascript" src="../userstore/extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>

<jsp:useBean id="userBean" type="org.wso2.carbon.user.ui.client.UserBean"
             class="org.wso2.carbon.user.ui.client.UserBean" scope="session"/>

<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
<jsp:include page="../userstore/display-messages.jsp"/>
<carbon:breadcrumb label="add.user"
                   resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
                   topPage="false" request="<%=request%>"/>

<script type="text/javascript">
    function doValidation() {
        var reason = "";
                
        var fld = document.getElementsByName("username")[0];
        if(!validateName(fld.value)){
            return false;
        }

        reason = validatePassword("password", "retype");
        if (reason != "") {
            if (reason == "Empty Password") {
                CARBON.showWarningDialog("<fmt:message key="enter.the.same.password.twice"/>");
            } else if (reason == "Min Length") {
                CARBON.showWarningDialog("<fmt:message key="password.mimimum.characters"/>");
            } else if (reason == "Invalid Character") {
                CARBON.showWarningDialog("<fmt:message key="invalid.character.in.password"/>");
            } else if (reason == "Password Mismatch") {
                CARBON.showWarningDialog("<fmt:message key="password.mismatch"/>");
            }
            return false;
        }
        return true;
    }

    function showHideUsers(element) {
        element.style.display = (element.style.display != 'block') ? 'block' : 'none';
    }


    function doCancel() {
        location.href = 'user-mgt.jsp?ordinal=1';
    }

    function doNext() {
        document.dataForm.action = "add-step2.jsp";
        if (doValidation() == true) {
            document.dataForm.submit();
        }
    }

    function doFinish() {
        document.dataForm.action = "add-finish.jsp";
        if (doValidation() == true) {
            document.dataForm.submit();
        }
    }

</script>
<div id="middle">
    <h2><fmt:message key="add.user"/></h2>

    <div id="workArea">
        <h3><fmt:message key="step.1.user"/></h3>

        <form method="post" action="add-finish.jsp" name="dataForm">
            <table class="styledLeft" id="userAdd" width="60%">
                <thead>
                    <tr>
                        <th><fmt:message key="enter.user.name"/></th>
                    </tr>
                </thead>
                <tr>
                    <td class="formRaw">
                        <table class="normal">
                            <tr>
                                <td><fmt:message key="user.name"/><font color="red">*</font>
                                </td>
                                <td><input type="text" name="username"
                                           value="<jsp:getProperty name="userBean" property="username" />"
                                           style="width:150px"/></td>
                            </tr>
                            <tr>
                                <td><fmt:message key="password"/><font color="red">*</font></td>
                                <td><input type="password" name="password" style="width:150px"/></td>
                            </tr>
                            <tr>
                                <td><fmt:message key="password.repeat"/><font
                                        color="red">*</font></td>
                                <td><input type="password" name="retype" style="width:150px"/></td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td class="buttonRow">
                        <input type="button" class="button" value="<fmt:message key="next"/> >" onclick="doNext();"/>
                        <input type="button" class="button" value="<fmt:message key="finish"/>" onclick="doFinish();"/>
                        <input type="button" class="button" value="<fmt:message key="cancel"/>" onclick="doCancel();"/>
                    </td>
                </tr>
            </table>
        </form>
    </div>
    <p>&nbsp;</p>
</div>
</fmt:bundle>