<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.CarbonError"%>
<%@page import="org.wso2.carbon.user.ui.client.HTMLEncoder"%>

<%@page import="org.wso2.carbon.user.core.UserCoreConstants"%><script type="text/javascript" src="extensions/js/vui.js"></script>
<script type="text/javascript" src="../extensions/core/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

    <%
    boolean showFilterMessage = false;
    String[] datas = null;
    String filter = (String)request.getParameter("org.wso2.usermgt.external.filter");
    if(filter == null){
       filter = (String)session.getAttribute("org.wso2.usermgt.external.filter");
    }
    
    if(filter == null){
       filter = "";
       session.removeAttribute("org.wso2.usermgt.external.filter");
    }else{
       filter = filter.trim();
       session.setAttribute("org.wso2.usermgt.external.filter", filter);
    }
        
    try {
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        UserMgtClient client = new UserMgtClient(cookie, backendServerURL, configContext);
        if(filter.length() > 0){
            datas = client.listExternalUsers(filter);
            if(datas == null || datas.length == 0){
                showFilterMessage = true;
            }
        }
    } catch (Exception e) {
    	session.removeAttribute("org.wso2.usermgt.external.filter");
    	String message = "Unable to retrieve users from the external user store. "+
    								"Please click on the main menu to continue.";
        CarbonUIMessage uiMsg = new CarbonUIMessage(message, CarbonUIMessage.ERROR, e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
        <jsp:include page="../admin/error.jsp"/>
<%
        return;
    }
      %>
<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
<carbon:breadcrumb label="external.users"
		resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
		topPage="false" request="<%=request%>" />
		
    <script type="text/javascript">
       <% if(showFilterMessage == true){ 
           session.removeAttribute("org.wso2.usermgt.external.filter");
       %>
		jQuery(document).ready(function() {
           CARBON.showInfoDialog('<fmt:message key="no.users.filtered"/>', null, null);
  		});
      <% } %>
    </script>


      
        <div id="middle">
        <h2><fmt:message key="external.users"/></h2>
        <div id="workArea">
            <form name="filterForm" method="post" action="ex-user-mgt.jsp">
                <table class="normal">
                    <tr>
                        <td><fmt:message key="list.users"/></td>
                        <td>
                           <input type="text" name="org.wso2.usermgt.external.filter" value="<%=filter%>"/>
                        </td>
                        <td>
                        <input class="button" type="submit" value="<fmt:message key="user.search"/>" />
                        </td>
                    </tr>
                </table>
            </form>
            <p>&nbsp;</p>
                  <table class="styledLeft">
                        <thead>
                        <tr>
                            <th><fmt:message key="name"/></th>
                            <th><fmt:message key="actions"/></th>
                        </tr>
                        </thead>
                        <tbody>
                        <%
                            int count = 0;
                            if (datas != null) {
                                for (String data : datas) {
                                    if (data != null) { //Confusing!!. Sometimes a null object comes. Maybe a bug Axis!!
                                	   
                                	   if(count == UserMgtClient.MAX_USER_COUNT){
                                            break;
                                       }
                                	   count ++;
                        %>
                        <tr>
                            <td><%=HTMLEncoder.encode(data)%>
                            </td>
                            <td>
        <%
        if(CarbonUIUtil.isContextRegistered(config, "/userprofile/")){
        %>
        <a href="../userprofile/index.jsp?username=<%=data%>&userstore=<%=UserCoreConstants.INTERNAL_USERSTORE%>" class="icon-link" style="background-image:url(../userprofile/images/my-prof.gif);">User Profile</a>
        <%
            }
        %>
                            </td>
                        </tr>
                        <%
                                    }
                                }
                            }
                        %>
                        </tbody>
                        </table>
                        <p>&nbsp;</p>
                        <%
		                if(datas != null){
		                    int length = datas.length; 
		                    if(length > UserMgtClient.MAX_USER_COUNT){
		                    %>
		                    <strong><fmt:message key="more.users"/></strong>
		                    <%
		                    }
		                }
                        %>
                        <table>
                        <tr>
                              <td class="buttonRow" colspan="2">
                                  <form action="index.jsp">
                                        <input value="<fmt:message key="finish"/>" type="submit" onclick="addToHistory();" class="button"/>
                                  </form>
                              </td>
                        </tr>                        
                    </table>
        </div>
    </div>
</fmt:bundle>